# This file is a template, and might need editing before it works on your project.
# To contribute improvements to CI/CD templates, please follow the Development guide at:
# https://docs.gitlab.com/ee/development/cicd/templates.html
# This specific template is located at:
# https://gitlab.com/gitlab-org/gitlab/-/blob/master/lib/gitlab/ci/templates/Getting-Started.gitlab-ci.yml

# This is a sample GitLab CI/CD configuration file that should run without any modifications.
# It demonstrates a basic 3 stage CI/CD pipeline. Instead of real tests or scripts,
# it uses echo commands to simulate the pipeline execution.
#
# A pipeline is composed of independent jobs that run scripts, grouped into stages.
# Stages run in sequential order, but jobs within stages run in parallel.
#
# For more information, see: https://docs.gitlab.com/ee/ci/yaml/index.html#stages
include:
  template: Jobs/Code-Quality.gitlab-ci.yml

stages:          # List of stages for jobs, and their order of execution
  - test
  - release

before_script:
  - apt-get update
  - apt-get -y install zip unzip
  - apt-get -y install npm
  - npm install npm@latest -g
  - npm install -g n
  - npm install mocha
  - npm install chai
  - npm install eslint
  - npm i

unit-test-job:   # will update later, doesnt actually run any unit tests yet
  stage: test  
  script:
    - echo "Running unit tests... This will take about 60 seconds."
    - echo "Code coverage is 90%"

lint-Backend:   # runs lint on backend
  stage: test
  script:
    - echo "Running linter on backend."
    - npm i
    - npm run lint -- --fix

release:      
  stage: release 
  script: script
    - echo "Deploying application..."
    - echo "Application successfully deployed."
